﻿var IOW = IOW || {};
IOW.notification = IOW.notification || {};
(function ($) {

    var spinner;

    IOW.notification = {
        Settings: function (notificationModel, messageBox, errorBox, submitButton, cancelButton, closeButton, nameControl, emailControl, nameInput, emailInput, nameFieldValidation, emailFieldValidation, pageId, subscriptionSentText, subscriptionFailedText, emailNotValidText, emailExistsText, inputNotValidText, nameEmptyText, sendingText) {
            this.NotificationModel = notificationModel,
            this.MessageBox = messageBox,
            this.ErrorBox = errorBox,
            this.SubmitButton = submitButton;
            this.CancelButton = cancelButton;
            this.CloseButton = closeButton;
            this.NameControl = nameControl;
            this.EmailControl = emailControl;
            this.NameInput = nameInput;
            this.EmailInput = emailInput;
            this.NameFieldValidation = nameFieldValidation;
            this.EmailFieldValidation = emailFieldValidation;
            this.SubmitButton = submitButton;
            this.PageId = pageId;
            this.SubscriptionSentText = subscriptionSentText;
            this.SubscriptionFailedText = subscriptionFailedText;
            this.EmailNotValidText = emailNotValidText;
            this.EmailExistsText = emailExistsText;
            this.InputNotValidText = inputNotValidText;
            this.NameEmptyText = nameEmptyText;
            this.SendingText = sendingText;
        },

        loadModal: function (settings) {

            var notificationModel = $(settings.NotificationModel);

            var nameControl = $(settings.NameControl);
            var emailControl = $(settings.EmailControl);
            var subscriberNameInput = $(settings.NameInput);
            var subscriberEmailInput = $(settings.EmailInput);
            var nameFieldValidation = $(settings.NameFieldValidation);
            var emailFieldValidation = $(settings.EmailFieldValidation);

            var messageBox = $(settings.MessageBox);
            var errorBox = $(settings.ErrorBox);

            //Events
            notificationModel.on('shown', function () {
                subscriberNameInput.focus();
                var overlay = $(".epi-overlay-container", window.parent.document)
                if (overlay)
                    overlay.css("display", "none");
            });

            //Clean up when modal is closing
            notificationModel.on('hide', function () {
                clearValidation();
                clearTextFields();
                messageBox.show();
                errorBox.hide();
                var overlay = $(".epi-overlay-container", window.parent.document)
                if (overlay)
                    overlay.css("display", "block");
            });

            var submitButton = $(settings.SubmitButton);
            submitButton.click(function (event) {
                event.preventDefault();
                if (validate()) {
                    var name = subscriberNameInput.val();
                    var epost = subscriberEmailInput.val();
                    IOW.notification.showProgress(settings);
                    IOW.notification.postData(settings, name, epost);
                }
            });

            var cancelButton = $(settings.CancelButton);
            cancelButton.click(function (event) {
                event.preventDefault();
                notificationModel.modal('hide');
            });

            var closeButton = $(settings.CloseButton);
            closeButton.click(function (event) {
                notificationModel.modal('hide');
                return false;
            });

            //Press return key
            subscriberNameInput.keypress(function (e) {
                if ((e.which && e.which == 13) || (e.keyCode && e.keyCode == 13)) {
                    submitButton.click();
                    return false;
                } else {
                    return true;
                }
            });

            //Press return key
            subscriberEmailInput.keypress(function (e) {
                if ((e.which && e.which == 13) || (e.keyCode && e.keyCode == 13)) {
                    submitButton.click();
                    return false;
                } else {
                    return true;
                }
            });

            //Help methods
            function validateEmail(email) {
                var emailReg = /^([a-zA-Z0-9_\-\.]+)@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.)|(([a-zA-Z0-9\-]+\.)+))([a-zA-Z]{2,4}|[0-9]{1,3})(\]?)$/;
                return emailReg.test(email);
            }

            function clearValidation() {
                nameControl.removeClass('error');
                emailControl.removeClass('error');
                nameFieldValidation.text('');
                emailFieldValidation.text('');
            }

            function clearTextFields() {
                subscriberNameInput.val('');
                subscriberEmailInput.val('');
            }

            function validate() {
                var returnValue = true;
                clearValidation();

                if (subscriberEmailInput.val().length < 1) {
                    emailControl.addClass('error');
                    subscriberEmailInput.focus();
                    returnValue = false;
                } else if (!validateEmail(subscriberEmailInput.val())) {
                    emailFieldValidation.text(settings.EmailNotValidText);
                    emailControl.addClass('error');
                    subscriberEmailInput.focus();
                    returnValue = false;
                }

                if (subscriberNameInput.val().length < 1) {
                    nameControl.addClass('error');
                    subscriberNameInput.focus();
                    returnValue = false;
                }

                return returnValue;
            }
        },

        postData: function (settings, name, epost) {
            var subscriberData = '{"name":"' + name +
                '","emailAddress":"' + epost +
                '","pageId":' + settings.PageId + '}';

            var hostName = window.location.hostname;
            var clubName = window.location.pathname.split("/")[1];
            var assemblyUrl = "/" + clubName + '/Notification/Svc/NotificationControlService.svc/Subscribe';
            var originalUrl = '/Notification/Svc/NotificationControlService.svc/Subscribe';
            var actualUrl = "";
            if (hostName == "idrottonline.se" || hostName == "test.idrottonline.se" || hostName == "dev.idrottonline.se")
            {
                actualUrl = assemblyUrl
            } else
            {
                actualUrl = originalUrl
            }
            
            $.ajax({
                url: actualUrl,
                type: 'POST',
                dataType: 'json',
                contentType: 'application/json;charset=utf-8',
                data: subscriberData,
                success: function (data) {
                    if (data) {
                        var d = $.parseJSON(data);
                        IOW.notification.loadPostBackModal(d.Status, settings);
                    }
                },
                error: function (ex) {
                    //console.log(ex.statusText);
                    IOW.notification.loadPostBackModal('Error', settings);
                }
            });
        },

        showProgress: function (settings) {
            var submitButton = $(settings.SubmitButton);
            var cancelButton = $(settings.CancelButton);
            var closeButton = $(settings.CloseButton);

            spinner = iosOverlay({
                text: settings.SendingText,
                spinner: IOUI.spinner
            });

            submitButton.attr('disabled', 'disabled');
            cancelButton.attr('disabled', 'disabled');
            closeButton.attr('disabled', 'disabled');
        },

        hideProgress: function (settings, type, spinnerText) {
            var submitButton = $(settings.SubmitButton);
            var cancelButton = $(settings.CancelButton);
            var closeButton = $(settings.CloseButton);

            var delayTime = 1500;
            if (type == 'ok') {
                $('.ios-overlay-show').addClass('font-size');
                delayTime = 3000;
            }

            if (type) {
                spinner.update({
                    text: !spinnerText ? " " : spinnerText,
                    icon: "icon-" + type
                });
            }

            //Wait for 1500 ms
            setTimeout(function () {
                spinner.hide();
                submitButton.removeAttr('disabled');
                cancelButton.removeAttr('disabled');
                closeButton.removeAttr('disabled');
            }, delayTime);
        },

        loadPostBackModal: function (status, settings) {
            var notificationModel = $(settings.NotificationModel);

            var nameControl = $(settings.NameControl);
            var emailControl = $(settings.EmailControl);
            var subscriberNameInput = $(settings.NameInput);
            var subscriberEmailInput = $(settings.EmailInput);
            var nameFieldValidation = $(settings.NameFieldValidation);
            var emailFieldValidation = $(settings.EmailFieldValidation);
            var messageBox = $(settings.MessageBox);
            var errorBox = $(settings.ErrorBox);

            if (status == 'OK') {
                IOW.notification.hideProgress(settings, 'ok', settings.SubscriptionSentText);
                notificationModel.modal('hide');
            }
            else if (status == 'Error' || status == 'InputNotValid') {
                IOW.notification.hideProgress(settings, 'remove', '');

                messageBox.hide();
                errorBox.show();

                if (status == 'InputNotValid') //Server validation failed, client should catch this
                    errorBox.text(settings.InputNotValidText);
                else if (status == 'Error')
                    errorBox.text(settings.SubscriptionFailedText);
            } else {
                IOW.notification.hideProgress(settings, '', '');

                if (status == 'NameEmpty') {
                    nameFieldValidation.text(settings.NameEmptyText);
                    nameControl.addClass('error');
                    subscriberNameInput.focus();
                } else {
                    emailControl.addClass('error');
                    subscriberEmailInput.focus();

                    if (status == 'EmailNotValid')
                        emailFieldValidation.text(settings.EmailNotValidText);
                    else if (status == 'EmailExists')
                        emailFieldValidation.text(settings.EmailExistsText);
                }
            }
        }
    };

})(jQuery);